import { UsernameEntity } from '@modules/authentication/core/domain/username.entity';
import {
  CreateUsernameProps,
  Type,
} from '@modules/authentication/core/domain/username.types';

const createUsernameProps: CreateUsernameProps = {
  userId: '165192d4-398a-4469-a16b-98c02cc6f531',
  type: Type.EMAIL,
  name: 'john.doe@email.com',
};

describe('Username entity create', () => {
  it('should create a new username entity', async () => {
    const usernameEntity: UsernameEntity = await UsernameEntity.create(
      createUsernameProps,
    );
    expect(usernameEntity.id).toBe('john.doe@email.com');
    expect(usernameEntity.domainEvents.length).toBe(1);
  });
});
