import { UsernameMapper } from '@modules/authentication/username.mapper';
import { PrismaService } from '@modules/authentication/infrastructure/prisma.service';
import { EventEmitter2, EventEmitterModule } from '@nestjs/event-emitter';
import { Test, TestingModule } from '@nestjs/testing';
import { UsernameRepository } from '@modules/authentication/infrastructure/username.repository';

const mockMessagePublisher = {
  publish: jest.fn().mockImplementation(),
};

describe('Username repository', () => {
  let prismaService: PrismaService;
  let usernameMapper: UsernameMapper;
  let eventEmitter: EventEmitter2;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [EventEmitterModule.forRoot()],
      providers: [PrismaService, UsernameMapper],
    }).compile();

    prismaService = module.get<PrismaService>(PrismaService);
    usernameMapper = module.get<UsernameMapper>(UsernameMapper);
    eventEmitter = module.get<EventEmitter2>(EventEmitter2);
  });
  it('should be defined', () => {
    expect(
      new UsernameRepository(
        prismaService,
        usernameMapper,
        eventEmitter,
        mockMessagePublisher,
      ),
    ).toBeDefined();
  });
});
